/* Разработал Белозеров А.
 E-mail: belalni@gmail.com

!ПИН 4  - управление ВХОДОМ 1
!ПИН 5  - управление ВХОДОМ 2
!ПИН 6  - управление ВХОДОМ 3
!ПИН A4 - управление ВХОДОМ 4
!ПИН A5 - управление ВХОДОМ 5 (FM радио)
!ПИН 7  - кнопка управления коммутацией АУДИО ВХОДОВ
 
!ПИН 9  - управление колонкой А, шина +
!ПИН 10 - управление колонкой А, шина -
!ПИН 11 - управление колонкой В, шина +
!ПИН 12 - управление колонкой В, шина -
!ПИН A0 - кнопка коммутации колонок

!ПИН 8  - выход сервопривода
!ПИН 3  - вход CLK дисплея
!ПИН 2  - вход DIO дисплея
!ПИН А2 - ЭНКОДЕР +
!ПИН А3 - ЭНКОДЕР -
*/
#include "TM1637.h"            // библиотека для работы с дисплеем TM1637
#define CLK 3                  // пин 3 - вход CLK дисплея
#define DIO 2                  // пин 2 - вход DIO дисплея
#include <RotaryEncoder.h>     // библиотека для работы с энкодером
#include <Servo.h>             // библиотека для работы с сервоприводом
//------------ переменные и объекты --------------------------------------
Servo myservo;                 // объявляем объект сервопривода
TM1637 tm1637(CLK,DIO);        // объявляем объект дисплея
int j=1;                       // вспомогательная переменная
int servo = 1;                 // переменная серво
int N = 0;                     // вспомогательная переменная
int pos = 0;                   // счетчик энкодера
int newPos = 1;                // новая позиция энкодера
//------------------------------------------------------------------------
int   flag_kolonki = 0;        // флаг коммутации колонок
int   flag_vxodi   = 0;        // флаг коммутации аудио входов
byte  knopka_kolonki;          // переменная обслуживания кнопки колонок
byte  knopka_vxodi;            // переменная обслуживания кнопки аудио входов
//========================================================================
RotaryEncoder encoder(A2, A3); // определяем входы энкодера А2, А3
int encoderLastPos;            // предыдущая позиция энкодера
unsigned long encoderLastTime; // предыдущее время энкодера
//------------------------------------------------------------------------

//------------------------------------------------------------------------
byte  kolon_A_1 = 9;           // управление колонкой А, шина +
byte  kolon_A_2 = 10;          // управление колонкой А, шина -
byte  kolon_B_1 = 11;          // управление колонкой В, шина +
byte  kolon_B_2 = 12;          // управление колонкой В, шина -
byte  pin = A0;                // коммутация колонок (кнопка)
byte  pin2 = 4;                // ВХОД 1
byte  pin3 = 5;                // ВХОД 2
byte  pin4 = 6;                // ВХОД 3
byte  pin5 = A4;               // ВХОД 4
byte  pin6 = A5;               // ВХОД 5 (FM радио)
byte  pin7 = 7;                // коммутация АУДИО ВХОДОВ (кнопка)
//========================================================================
void setup() 
{
  myservo.attach(8);           // выход сервопривода
  tm1637.set(4);               // яркость дисплея (BRIGHT_TYPICAL = 2, BRIGHT_DARKEST = 0, BRIGHTEST = 7;)
  myservo.write(0);            // установили серво в 0
  //-----------------------------------------------------------------------
  pinMode(pin, INPUT);                        // A0 пин установили как вход (КНОПКА)
  digitalWrite(pin, HIGH);                    // подтянули к питанию
  pinMode(pin7, INPUT);                       // 7 пин установили как вход (КНОПКА)
  digitalWrite(pin7, HIGH);                   // подтянули к питанию
  //-----------------------------------------------------------------------
  pinMode(pin2,  OUTPUT);                     // 4 пин установили как ВЫХОД
  pinMode(pin3,  OUTPUT);                     // 5 пин установили как ВЫХОД
  pinMode(pin4,  OUTPUT);                     // 6 пин установили как ВЫХОД
  pinMode(pin5,  OUTPUT);                     // А4 пин установили как ВЫХОД
  pinMode(pin6,  OUTPUT);                     // А5 пин установили как ВЫХОД

  pinMode(kolon_A_1, OUTPUT);                 // 9 пин установили как ВЫХОД
  pinMode(kolon_A_2, OUTPUT);                 // 10 пин установили как ВЫХОД
  pinMode(kolon_B_1, OUTPUT);                 // 11 пин установили как ВЫХОД
  pinMode(kolon_B_2, OUTPUT);                 // 12 пин установили как ВЫХОД
  digitalWrite(kolon_A_1, HIGH);
  digitalWrite(kolon_A_2, HIGH);
  digitalWrite(kolon_B_1, HIGH);
  digitalWrite(kolon_B_2, HIGH);
  //-----------------------------------------------------------------------
                  tm1637.init();              // инициализация дисплея
                  digitalWrite(pin2, LOW); 
                  digitalWrite(pin3, LOW); 
                  digitalWrite(pin4, LOW); 
                  digitalWrite(pin5, LOW); 
                  digitalWrite(pin6, HIGH);   // включили 5 выход (FM радио)
                  tm1637.display(3, 5);       // в 3 символе дисплея вывели 5
                  flag_vxodi = 0;             // сбросили флаг входов, при нажатии на кнопку 
				                              // выбора входов на дисплее появится 1
  }
//=======================================================================================================
// tm1637.display(N, false)   - очистить сегмент N = 0...3
// tm1637.display(3, 16)      - установить символ с кодом 16 в сегмент 3
// tm1637.display(D, R)       - D сегмент 0...3, R - даные 0...99 (код по таблице символов)

void loop() 
{
  delay (5000);                    // задержка на переходные процессы в усилителе, 5 с
  digitalWrite(kolon_A_1, LOW);    // включили колонки А и В (коммутация происходит нулем, так как в 
  digitalWrite(kolon_A_2, LOW);    // исполнительном механизме стоит оптрон, запитанный +5В)
  digitalWrite(kolon_B_1, LOW);
  digitalWrite(kolon_B_2, LOW);
  tm1637.display(2, 16);           // вывели символ "-" с кодом 16 в третий сегмент индикатора (0-1-2-3)
  flag_kolonki=1;                  // установили флаг коммутации колонок в 1 (колонки включены)
  int i;
//=======================================================================================================
    static int pos = 0;

metka2:
    encoder.tick();                        // "слушаем" энкодер...
    newPos = encoder.getPosition();        // приняли новые данные с энкодера
if ((newPos >= 61) || (newPos <= 0))       // если данные больше 61 или меньше 0 то уходим на метку (переполнение)
    {goto metka1;}
    else {myservo.write(newPos*4);}        // пишем в серво, тут умножаем на 4 потому что у сервы 180 градусов, а наш диапазон на индикаторе 45 значений
//-------------------------------------------------------------------------------------------------------
	if   (newPos <= 0)                     // если энкодер не двигается...
         {newPos = 0; goto metka1;}        // зануляем значение и выходим
    else {if (newPos == pos) goto metka1;  // энкодер работает?
//-------------------------------------------------------------------------------------------------------
          else {if (newPos <= 9) {tm1637.display(0, 0); tm1637.display(1, newPos); goto metka1;}
                else {if (newPos < 20) {if (newPos == 10) {tm1637.display(0, 1); tm1637.display(1, 0); goto metka1;}            // 10
                                        else {int k10 = newPos - 10; tm1637.display(0, 1); tm1637.display(1, k10);} goto metka1;}
	                  if (N == 20) {tm1637.display(0, 2); tm1637.display(1, 0); goto metka1;}
					  else { if (newPos < 30) {int k20 = newPos - 20; tm1637.display(0, 2); tm1637.display(1, k20); goto metka1;}
					         else { if (newPos == 30) {tm1637.display(0, 3); tm1637.display(1, 0); goto metka1;}
							        else{ if (newPos < 40) {int k30 = newPos - 30; tm1637.display(0, 3); tm1637.display(1, k30); goto metka1;}
									       else { if (newPos == 40) {tm1637.display(0, 4); tm1637.display(1, 0); goto metka1;} 
										          else {if (newPos < 50) {int k40 = newPos - 40; tm1637.display(0, 4); tm1637.display(1, k40); goto metka1;} 
										               else {if (newPos == 50) {tm1637.display(0, 5); tm1637.display(1, 0); goto metka1;}
										                     else {if (newPos < 60) {int k50 = newPos - 50; tm1637.display(0, 5); tm1637.display(1, k50); goto metka1;} 
										                           else {if (newPos == 60) {tm1637.display(0, 6); tm1637.display(1, 0); goto metka1;}
										                                 else {goto metka1;}}}}}}}
} // не пытайтесь понять то, что написано выше
  // общий смысл того, что написано: это большой дешифратор с выводом значения на дисплей
} // например у нас есть значение 32, этот дешифратор раскладывает его на 3 десятка и 2, выводя на дисплей 32 поразрядно!!!
  // 3 в 0 разряд дисплея, 2 в 1 разряд дисплея. Эту задачу можно решить проще, целочисленным делением, но уже поздно :)
} // дешифратор написан до 60, на самом деле используем до 45. Можно дописать его до 90, при этом умножать значение не на 4
  // а на 6 или 8 кому как нравится.
}
}
metka1:
//===== ВКЛЮЧЕНИЕ КОЛОНОК, ЕСЛИ ФЛАГ 0 ====================================================
  knopka_kolonki = digitalRead(pin);                    // Проверка кнопки коммутации колонок

  if ((knopka_kolonki == LOW) && (flag_kolonki == 0))   // смотрим на флаг колонок и нажатие на кнопку
  { 
    delay (300);
  digitalWrite(kolon_A_1, LOW);                         // коммутирует нулем
  digitalWrite(kolon_A_2, LOW);
  digitalWrite(kolon_B_1, LOW);
  digitalWrite(kolon_B_2, LOW);
    flag_kolonki = 1;                     // ставим флаг колонок
    tm1637.display(2, 16);
    delay (500);
  }
//====== ВЫКЛЮЧЕНИЕ КОЛОНОК, ЕСЛИ ФЛАГ 1 ===================================================

  knopka_kolonki = digitalRead(pin);               

  if ((knopka_kolonki == LOW) && (flag_kolonki == 1))
  {  
    delay (300);
  digitalWrite(kolon_A_1, HIGH);
  digitalWrite(kolon_A_2, HIGH);
  digitalWrite(kolon_B_1, HIGH);
  digitalWrite(kolon_B_2, HIGH);
    flag_kolonki = 0;                      // обнуляем флаг колонок
    tm1637.display(2, 17);
    delay (500);
  } 
//==== Проверка кнопки КОММУТАЦИИ АУДИО ВХОДЫ ==============================================
  
  knopka_vxodi = digitalRead(pin7);               // с переменной работать удобнее, чем с функцией, читаем кнопку...
  if ((knopka_vxodi == LOW) && (flag_vxodi == 0)) // проверяем флаг и кнопку
  {  
    delay (300);
    digitalWrite(pin2, HIGH);      // включили 1 вход
    digitalWrite(pin3, LOW); 
    digitalWrite(pin4, LOW); 
    digitalWrite(pin5, LOW); 
    digitalWrite(pin6, LOW); 
    tm1637.display(3, 1);          // вывели 1
    flag_vxodi = 1;                // нарастили флаг
    delay (500);
  }            
               knopka_vxodi = digitalRead(pin7);
               if ((knopka_vxodi == LOW) && (flag_vxodi == 1))
               {  
                  delay (300);
                  digitalWrite(pin2, LOW); 
                  digitalWrite(pin3, HIGH);  // включили 2 вход
                  digitalWrite(pin4, LOW); 
                  digitalWrite(pin5, LOW); 
                  digitalWrite(pin6, LOW);
                  tm1637.display(3, 2);      // вывели 2
                  flag_vxodi = 2;            // нарастили флаг
                  delay (500);
                }
				              							  
                             knopka_vxodi = digitalRead(pin7);
                             if ((knopka_vxodi == LOW) && (flag_vxodi == 2))
                             {  
                                delay (300);
                                digitalWrite(pin2, LOW); 
                                digitalWrite(pin3, LOW); 
                                digitalWrite(pin4, HIGH);   // включили 3 вход
                                digitalWrite(pin5, LOW); 
                                digitalWrite(pin6, LOW);
                                tm1637.display(3, 3);       // вывели 3
                                flag_vxodi = 3;             // нарастили флаг
                                delay (500);
                             }
							 
							                                            knopka_vxodi = digitalRead(pin7);
                                           if ((knopka_vxodi == LOW) && (flag_vxodi == 3))
                                           {  
                                              delay (300);
                                              digitalWrite(pin2, LOW); 
                                              digitalWrite(pin3, LOW); 
                                              digitalWrite(pin4, LOW); 
                                              digitalWrite(pin5, HIGH);  // включили 4 вход
                                              digitalWrite(pin6, LOW);
                                              tm1637.display(3, 4);      // вывели 4
                                              flag_vxodi = 4;            // нарастили флаг
                                              delay (500);
                                           }
                                                         knopka_vxodi = digitalRead(pin7);
                                                         if ((knopka_vxodi == LOW) && (flag_vxodi == 4))
                                                         {  
                                                             delay (300);
                                                             digitalWrite(pin2, LOW); 
                                                             digitalWrite(pin3, LOW); 
                                                             digitalWrite(pin4, LOW); 
                                                             digitalWrite(pin5, LOW); 
                                                             digitalWrite(pin6, HIGH); // включили 5 вход
                                                             tm1637.display(3, 5);     // вывели 5
                                                             flag_vxodi = 0;           // обнулили флаг, т.е. пойдем шагать сначала
                                                             delay (500);
                                                         }
  
    
goto metka2;  // уходим в начало цикла опроса, на опрос энкодера
}
//====================================== конец ==========================================
